$(document).ready(function() {
    
    if($("section._connections").length) {
        
        var $selected = $("section._conections_select .code");

        // ====== Get files list ======
        var path = $("section._connections input.action").val();
        var prefix = path.split("*").shift();
        var files_list = new Object();
        var files = [];

        $("nav dd").each(function() {
            href = $(this).find(".item_label").first().attr("href");
            
            if(href.indexOf(prefix) == 0 && href.split("/").length == path.split("/").length) {
                
                // pages/<folder>/
                if(path == prefix) {
                    dir = href.split("/");
                    file = dir.pop();
                    dir = dir.pop();
                }
                // pages/<folder>/*/
                else {
                    href = href.substr(prefix.length);
                    dir = href.split("/");
                    file = dir.pop();
                    dir = dir.join("/");
                }

                if(files_list[dir] == undefined) {
                    files_list[dir] = [];
                }
                files = files_list[dir];
                files[files.length] = file.path("filename");
                files_list[dir] = files;
            }
        });
        
        function getSelected($selected, files_list, verify_flag) {
            // ====== Get selected ======
            var selected = $selected.val();
            if(selected != "") {
                selected = selected.split("\n");
            }
            else {
                selected = [];
            };
            // ====== Verify (optional) ======
            if(verify_flag) {
                verified = [];
                for(dir in files_list) {
                    files = files_list[dir];
                    for(i in files) {
                        file = files[i];
                        path = dir + "/" + file;
                        if(selected.indexOf(path) >= 0) {
                            verified[verified.length] = path;
                        }
                    }
                };
                if(selected.length != verified.length) {
                    selected = verified;
                    $selected.val( selected.join("\n") );
                };
            };
            // ====== Output ======
            return selected;
        }

        function selectConnections($selected, files_list) {
            var selected = getSelected($selected, files_list, false)
            // ====== POPUP content ======
            popup_title = $selected.closest("article").find(".action_button").text();
            $("#page_fader, #popup_container").remove();
            // Build HTML
            html = "<div id='page_fader'></div>";
            html = html + "<div id='popup_container'><div id='popup_box'>";
            html = html + "<h3>" + popup_title + "</h3>";
            html = html + "<div class='connections'>";
            // Path group
            for(dir in files_list) {
                html = html + "<details><summary>" + dir.replace(/\//g, " / ") + "</summary>";
                
                // Files list
                files = files_list[dir];
                for(i in files) {
                    filename = files[i];
                    path = dir + "/" + filename;
                    if(selected.indexOf(path) >= 0) {
                        var checked = "checked";
                    }
                    else {
                        var checked = "";
                    };
                    
                    html = html + "<label><input type='checkbox' name='connections[]' value='" + path + "'" + checked + ">" + filename.replace(/_/g, " ") + "</label>";
                }
                html = html + "</details>";
            }
            html = html + "</div>";
            // Buttons
            html = html + "<div class='buttons two'><button class='confirm'>" + LOCALIZE["ok-label"] + "</button><button class='cancel'>" + LOCALIZE["cancel-label"] + "</button></div>";
            // Close popup box & container
            html = html + "</div></div>";
            // Show popup
            $("body").append( html );
            $("#page_fader").fadeIn(500);
            // ====== Open selected groups ======
            if($("#popup_container .connections details").length == 1) {
                $("#popup_container .connections details").prop("open", true);
            }
            else {
                var opened = false;
                $("#popup_container .connections details").each(function() {
                    $details = $(this);
                    if($details.find("label input:checked").length) {
                        $details.prop("open", true);
                        opened = true;
                    }
                });
                if(!opened) { $("#popup_container .connections details").first().prop("open", true); };
            }

            // ====== Show POPUP ======
            $("#popup_container").fadeIn(250, function() {
                // ====== POPUP Actions ======
                // OK
                $("#popup_container .confirm").click(function() {
                    selected = [];
                    $("#popup_container .connections input").each(function() {
                        if($(this).prop("checked") == true) {
                            selected[selected.length] = $(this).val();
                        }
                    })
                    $selected.val( selected.join("\n") );
                    $("#page_fader, #popup_container").fadeOut(250, function() { $(this).remove(); });
                })
                // Cancel
                $("#popup_container .cancel").click(function() {
                    $("#page_fader, #popup_container").fadeOut(250, function() { $(this).remove(); });
                })
            });
        };
        
        // ====== Verify selected ======
        getSelected($selected, files_list, true);
        
        // ====== Connections select button ======
        $("section._connections .action_button").unbind("click").click(function() {
            selectConnections($selected, files_list);
            return false;
        });
        
    };
})