var ANIMATION_TIME = 250; 

$(document).ready(function() {
    $("#loader").fadeOut(ANIMATION_TIME);
    $("#popup_container").show();
    
    $("button.confirm").click(function() {
        current_pass = $("#current_password").val();
        new_pass = $("#new_password").val();
        confirm_pass = $("#confirm_password").val();
        if(current_pass.length == 0) {
            infoPopup(LOCALIZE["no-current-password"]); //Musisz podać aktualne hasło
            $("#current_password").focus();
            return false;
        }
        else if(new_pass.length < 6) {
            infoPopup(LOCALIZE["new-password-too-short"]); //Nowe hasło jest za krótkie
            $("#new_password").focus();
            return false;
        }
        else if(new_pass != confirm_pass) {
            infoPopup(LOCALIZE["different-passwords"]); //Podane hasła różnią się
            $("#confirm_password").focus();
            return false;
        }
        else if(new_pass == current_pass) {
            infoPopup(LOCALIZE["same-passwords"]); //Obecne i nowe hasło są takie same
            $("#new_password").focus();
            return false;
        }
        else {
            $(this).blur();
            return true;
        };  
    });
    
    $("button.cancel").click(function() {
        $(this).blur();
        var href = $(this).attr("href");
        $("#loader").fadeIn(500, function() {
            location.href = href;
        })
        return false;
    });
    
    // ==========================================
    //              Initial actions
    // ==========================================
        
    if($("#redirect").length) {
        location.href = $("#redirect").val() + "?popup=" + encodeURIComponent(LOCALIZE["password-changed"] + "|done"); //Hasło zostało zmienione
    }
    else if($("#popup").length) {
        popup = $("#popup").val().split("\|");
        icon = false;
        if(popup.length > 1) {
            icon = popup.pop();
            message = popup.join("\|");
        }
        else {
            message = popup.shift();
        };
        infoPopup( message, icon );
    };
    
    initializeHelp();
    
});